  MEMBER
  
  INCLUDE('fauxMax.inc'),ONCE

FAUX_RECT                      GROUP,TYPE
Left                              SIGNED
Top                               SIGNED
Right                             SIGNED
Bottom                            SIGNED
                                End
  MAP
    MODULE('winApi')
      FAUX_GetWindowRect(FAUX_HWND hWnd, *FAUX_RECT lpRect),BOOL,Raw,Pascal,Proc,Name('GetWindowRect')
      FAUX_GetParent(FAUX_HWND hWnd),FAUX_HWND,Pascal,Name('GetParent')
      FAUX_MoveWindow(FAUX_HWND hWnd, UNSIGNED x, UNSIGNED y, UNSIGNED cx, UNSIGNED cy, BOOL bRedraw),BOOL,Pascal,Proc,Name('MoveWindow')
    END
  END

FauxMaxClass.Init        Procedure(WINDOW W, <*WindowResizeClass WRC>, SIGNED inXPos, SIGNED inYPos, SIGNED inWidth, SIGNED inHeight, Long bWatchMDIChildMax=True, *BYTE inMaximize)

  Code
  
  SELF.W &= W

  IF NOT OMITTED(WRC)
     SELF.WRC &= WRC
  END

  SELF.OrigXPos   = inXPos
  SELF.OrigYPos   = inYPos
  SELF.OrigWidth  = inWidth
  SELF.OrigHeight = inHeight

  SELF.GlobalMaximize &= inMaximize

  IF W{PROP:MDI} AND W{PROP:Resize} AND W{PROP:Max}
  
    SELF.hWnd = W{PROP:Handle}
    
    REGISTER(Event:Maximize, ADDRESS(SELF.OnMaximize), ADDRESS(SELF), W)
    
    IF bWatchMDIChildMax
       REGISTER(Event:MDIChildMaximize, ADDRESS(SELF.OnUserMaximize), ADDRESS(SELF), W)
    End
    
    IF (inMaximize = 1)
       POST(Event:Maximize)
    END
    
  ELSE
  
    SELF.MyMaximize = inMaximize
    
  END
  
  RETURN

FauxMaxClass.OnUserMaximize   Procedure()!,Byte,Protected,Proc

  CODE
  
  SELF.OnMaximize()
  
  RETURN 0

FauxMaxClass.GetMaximize Procedure()!,BYTE

  CODE
  
  RETURN(SELF.MyMaximize)

FauxMaxClass.OnMaximize    Procedure()!,Byte,Protected,Proc

rcFCA       Like(FAUX_RECT)

   CODE
   
   If SELF.W{PROP:Iconize}
      SELF.W{PROP:Iconize} = False
   End

   FAUX_GetWindowRect(FAUX_GetParent(SELF.hWnd), rcFCA)

   IF (SELF.MyMaximize = 0)
      FAUX_MoveWindow(SELF.hWnd, 0, 0, (rcFCA.Right - rcFCA.Left), (rcFCA.Bottom - rcFCA.Top), True)
      
      SELF.MyMaximize = 1 ; SELF.GlobalMaximize = 1
      
   ELSE
   
      SELF.W{PROP:WIDTH}  = SELF.OrigWidth
      SELF.W{PROP:HEIGHT} = SELF.OrigHeight
      SELF.W{PROP:YPOS}   = SELF.OrigYPos
      SELF.W{PROP:XPOS}   = SELF.OrigXPos
     
      SELF.MyMaximize = 0 ; SELF.GlobalMaximize = 0
   END
   
   If SELF.WRC &= NULL
      POST(Event:Sized)
   Else
      SELF.WRC.Resize()
   End
   
   Return 5 !Level:Notify don't call next event handler or accept

